/*!
 * FSI Server Interface
 * http://www.fsi-viewer.com
 *
 * Copyright (C) 2000-2013 NeptuneLabs GmbH - All rights reserved.
 *
 * Version: 1.6.8
 */

// --- CUSTOMIZABLE PARAMETERS ---
var fsiPresetFlashVersion='6,0,65,0';   // Default value for required Flash version
var fsiImageFallbackLinked=true;        // Add a link to Flash Player download location to the fallback image
var fsiTextFallbackActive=true;         // Activate text fallback?
var fsiTextFallbackText='Flash Player Required.\nWould you like to download the latest version of Flash Player now?';
var flashFallbackImage='';

//
// EDITING THE LINES BELOW IS NOT RECOMMENDED
//
function flashDetectorAdvanced(presetFlashVersion, imageFallbackLinked, textFallbackActive, textFallbackText, flashFallbackImage){

	this.flashVersion = 0;
	var flashDownload;
	var flashDownloadCab;

	this.init = function(){

		var scheme;
		if (window.location && window.location.protocol.indexOf('https') > -1) scheme='https://';
		else scheme='http://';
		flashDownload = scheme+'www.adobe.com/go/getflashplayer';
		flashDownloadCab = scheme+'download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab';
		var isIE  = (navigator.appVersion.indexOf("MSIE") != -1) ? true : false;
		var isWin = (navigator.appVersion.toLowerCase().indexOf("win") != -1) ? true : false;
		var isOpera = (navigator.userAgent.toLowerCase().indexOf("opera") != -1) ? true : false;

		if (isIE && isWin && !isOpera) {
			try {
				var axTester = new ActiveXObject("ShockwaveFlash.ShockwaveFlash.6");
				var axVersionFull = axTester.GetVariable("$version");
				if (axVersionFull){
					var regVersion = axVersionFull.match(/(\d+),\d+,\d+,\d+/);
					if (regVersion && regVersion[1]){
						this.flashVersion = parseInt(regVersion[1]);
					}
				}
			}
			catch (e){}
		}
		else {
			var napl;
			if (navigator.plugins) napl = navigator.plugins;
			else napl = false;
			if (napl && napl.length > 0 && (napl["Shockwave Flash 2.0"] || napl["Shockwave Flash"])) {
				var flashDesc = napl["Shockwave Flash" + (napl["Shockwave Flash 2.0"] ? " 2.0" : "")].description;
				this.flashVersion = parseInt(flashDesc.split(" ")[2].split(".")[0]);
			}
		}
		// Scan Win/IE Old
		if (this.flashVersion == 0 && isIE && isWin && !isOpera) {
			pushVBDetection();
		}

	};

	this.writeFlashCode = function (fsiurl, fallbackimg, parameters, returncode){

		var objcode='<object type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="'+flashDownloadCab;
		var emdcode='<embed type="application/x-shockwave-flash" pluginspage="'+flashDownload+'"';

		var params = new Object();
		if (parameters){
			var parameters = parameters.split(";");
			for (var c=0; c < parameters.length; c++){
				var parameter=parameters[c].split("=");
				if (parameter[1]) params[parameter[0].toLowerCase()]=parameter[1];
				else if (parameter!="") {
					alert("Wrong parameter: " + parameter);
				}
			}
		}

		var useVersion;
		if (params["version"]) {
			useVersion=decodeURI(params["version"]);
			params["version"]='';
		}
		else useVersion=presetFlashVersion;
		objcode+='#version='+useVersion+'"';

		addAutoParameters(params);

		var majorversion = useVersion.split(",")[0];

		if (this.flashVersion > 0 && this.flashVersion >= majorversion){
			var code;
			if (params["width"]) {
				code=' width="'+params["width"]+'"';
				objcode+=code;
				emdcode+=code;
				params["width"]='';
			}
			if (params["height"]) {
				code=' height="'+params["height"]+'"';
				objcode+=code;
				emdcode+=code;
				params["height"]='';
			}
			if (params["id"] || params["name"]) {
				objcode+=' id="'+params["id"]+'"';
				if (params["name"]) emdcode+=' name="'+params["name"]+'"';
				else emdcode+=' name="'+params["id"]+'"';
				params["id"]='';
				params["name"]='';
			}
			objcode+='>\n';
			params["src"]=xmlEscape(encodeURI(fsiurl));
			params["movie"]=xmlEscape(encodeURI(fsiurl));

			for (var pkey in params){
				if (params[pkey]){
					if (pkey != 'src') objcode+='<param name="'+pkey+'" value="'+decodeURI(params[pkey])+'"\/>\n';
					if (pkey != 'movie') emdcode+=' '+pkey+'="'+decodeURI(params[pkey])+'"';
				}
			}
			emdcode+='\/>';

			objcode+=emdcode+'\n';
			objcode+='<\/object>';
		}
		else if (fallbackimg){
			objcode='<img src="'+xmlEscape(fallbackimg)+'" border=0 />';
			if (imageFallbackLinked) objcode='<a href="'+flashDownload+'" target="_blank">'+objcode+'</a>';
			objcode='<p align="center">'+objcode+'</p>';
		}

		if (!objcode){
			if (textFallbackActive && confirm(textFallbackText)) top.location=flashDownload;
		}
		else if (returncode){
			return objcode;
		}
		else {
			document.write(objcode);
		}
	};

	this.writeXHTMLFlashCode = function(fsiurl, fallbackimg, parameters, returncode){

		var objcode='<object type="application/x-shockwave-flash" codebase="'+flashDownloadCab;

		var params = new Object();
		if (parameters){
			var parameters = parameters.split(";");
			for (var c=0; c < parameters.length; c++){
				var parameter=parameters[c].split("=");
				if (parameter[1]) params[parameter[0]]=parameter[1];
				else if (parameter!="") alert("Wrong parameter: " + parameter);
			}
		}

		var version;
		if (params["version"]) {
			version=params["version"];
			params["version"]='';
		}
		else version=presetFlashVersion;
		objcode+='#version='+version+'"';

		var majorversion = version.split(",")[0];

		if (this.flashVersion >= majorversion){
			fsiurl=xmlEscape(fsiurl);
			objcode+=' data="'+fsiurl+'"';
			if (params["width"]) {
				code=' width="'+params["width"]+'"';
				objcode+=code;
				params["width"]='';
			}
			if (params["height"]) {
				code=' height="'+params["height"]+'"';
				objcode+=code;
				params["height"]='';
			}
			if (params["id"] || params["name"]) {
				objcode+=' id="'+params["id"]+'"';
				params["id"]='';
			}
			objcode+='>\n';
			params["movie"]=xmlEscape(fsiurl);

			addAutoParameters(params);

			for (var pkey in params){
				if (params[pkey]){
					objcode+='<param name="'+pkey+'" value="'+params[pkey]+'"/>\n';
				}
			}

			objcode+='</object>';
		}
		else if (fallbackimg){
			objcode='<p align="center"><img src="'+xmlEscape(fallbackimg)+'" border=0 /></p>';
			if (imageFallbackLinked) objcode='<a href="'+flashDownload+'">'+objcode+'</a>';
		}

		if (!objcode){
			if (confirm(textFallbackText)) top.location=flashDownload;
		}
		else if (returncode){
			return objcode;
		}
		else {
			document.write(objcode);
		}
	};

	this.writeJSHTMLCode = function(fsiurl, fallbackimg, parameters){

		var params = new Object();
		if (parameters){
			var parameters = parameters.split(";");
			for (c=0; c < parameters.length; c++){
				parameter=parameters[c].split("=");
				if (parameter[1]) params[parameter[0]]=parameter[1];
				else if (parameter!="") alert("Wrong parameter: " + parameter);
			}
		}

		if (params["width"]) objwidth=params["width"];
		else alert('Missing width');
		if (params["height"]) objheight=params["height"];
		else alert('Missing height');
		if (params["bgcolor"]) objbgcolor=params["bgcolor"];
		else objbgcolor="";
		if (params["quality"]) objquality=params["quality"];
		else objquality="";
		if (params["wmode"]) objwmode=params["wmode"];
		else objwmode="";
		delete params["width"];
		delete params["height"];

		var htmlcode='<scr'+'ipt type="text/javascript">\n';
		
		htmlcode+='<!--\n';
		htmlcode+='\twriteFlashCode( "'+fsiurl+'",';
		htmlcode+='\n\t\t"'+fallbackimg+'",';
		htmlcode+='\n\t\t"width='+objwidth+';height='+objheight;

		for (var pkey in params){
			if (params[pkey]) htmlcode += ";" + pkey + "=" + params[pkey];
		}

		addAutoParameters(params);

		htmlcode+='");\n';
		
		htmlcode+='// -->\n';
		htmlcode+='</script>\n';
		htmlcode+='<noscript>\n';
		htmlcode+='\t<object type="application/x-shockwave-flash" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="'+flashDownloadCab+'#version='+presetFlashVersion+'" width="'+objwidth+'" height="'+objheight+'">\n';
		htmlcode+='\t\t<param name="movie" value="'+xmlEscape(fsiurl)+'" />\n';
	
		for (var pkey in params){
			if (pkey != "mobilesupport" && pkey != "mobileiossupport" && pkey != "mobileandroidsupport" && pkey != "mobilepopupautomode" && pkey != "mobiletouchtext") {
				htmlcode+='\t\t<param name="'+pkey+'" value="'+params[pkey]+'" />\n';
			}
		}

		
			htmlcode+='\t\t<embed src="'+xmlEscape(fsiurl)+'"\n';
			htmlcode+='\t\t\twidth="'+objwidth+'"\n';
			htmlcode+='\t\t\theight="'+objheight+'"\n';

			for (var pkey in params){
				if (pkey != "mobilesupport" && pkey != "mobileiossupport" && pkey != "mobileandroidsupport" && pkey != "mobilepopupautomode" && pkey != "mobiletouchtext") {
					htmlcode+='\t\t\t' + pkey + '="'+params[pkey]+'"\n';
				}
			}

			htmlcode+='\t\t\ttype="application/x-shockwave-flash"\n';
			htmlcode+='\t\t\tpluginspage="'+flashDownload+'">\n';
			htmlcode+='\t\t</embed>\n';
		
		htmlcode+='\t</object>\n';
		htmlcode+='</noscript>';

		return htmlcode;
	};
	

	this.warpInHTML = function(title, maincode, helperjs, externaljs, forPreview){

			var css = 'body,html{width:100%;height:100%;margin:0px;padding:0px;overflow:auto;}\n';
			css += 'embed,img,object,div{vertical-align:middle;padding:0px:margin:0px;}\n';

			htmlcode = '<!DOCTYPE HTML>\n';
			if(typeof(forPreview) != undefined && forPreview) htmlcode += interfaceControl.getPreviewWindowComment();
			htmlcode+='<html>\n';
			htmlcode+='<head>\n';
			htmlcode+='<meta http-equiv="content-type" content="text/html; charset=UTF-8">\n';
			htmlcode+='<title>';
			if (typeof(qdata['options_htmltitle']) != "undefined") htmlcode+=qdata['options_htmltitle'];
			htmlcode+='</title>\n';

			if (interfaceControl && typeof(interfaceControl.getPreviewWindowStyle) === "function"){
				htmlcode+=interfaceControl.getPreviewWindowStyle(css);
			}
			else {
				htmlcode += '<style type="text/css">\n' + css + '</style>\n';
			}

			if (externaljs) htmlcode+=externaljs;
			if (helperjs) htmlcode+=helperjs;
			htmlcode+='</head>\n';
			htmlcode+='<body>\n';

			htmlcode+=maincode;

			htmlcode+='</body>\n';
			htmlcode+='</html>\n';


		return htmlcode;
	};

	// Run VBScript detection part in old IE
	pushVBDetection = function(){
		var doc = '<scr' + 'ipt type="text/vbscript"\>\n';
		doc += 'On Error Resume Next\n';
		doc += 'Dim i\n';
		doc += 'For i = 30 to 6 Step -1\n';
		doc += 'If Not(IsObject(CreateObject("ShockwaveFlash.ShockwaveFlash." & i))) Then\n';
		doc += 'Else\n';
		doc += 'fsiFD.flashVersion = i\n';
		doc += 'Exit For\n';
		doc += 'End If\n';
		doc += 'Next\n';
		doc += '<\/scr' + 'ipt>\n';
		document.write (doc);
	};

	var addAutoParameters = function(params){
		if (!params["allowscriptaccess"]) {
			params["allowscriptaccess"]='always';
		}
		if (!params["allowfullscreen"]) {
			params["allowfullscreen"]='true';
		}

		if (!params["quality"]) {
			params["quality"]='high';
		}
	};

	var xmlEscape = function(val){
		val = val.replace(/</g, "&lt;");
		val = val.replace(/>/g, "&gt;");
		val = val.replace(/\"/g, "&quot;");
		val = val.replace(/\'/g, "&apos;");
		val = val.replace(/&/g, "&amp;");
		return val;
	};

}


function writeFlashCode(fsiurl, fallbackimg, parameters, returncode){
	if (fsiFDA) {
		var ret = fsiFDA.writeFlashCode(fsiurl, fallbackimg, parameters, returncode);
		if (returncode) return ret;
	}
}

function writeXHTMLFlashCode(fsiurl, fallbackimg, parameters, returncode){
	if (fsiFDA) {
		var ret = fsiFDA.writeXHTMLFlashCode(fsiurl, fallbackimg, parameters, returncode);
		if (returncode) return ret;
	}
}

function writeJSHTMLCode(fsiurl, fallbackimg, parameters){
	if (fsiFDA) {
		return fsiFDA.writeJSHTMLCode(fsiurl, fallbackimg, parameters);
	}
}

function warpInHTML(title, maincode, helperjs, externaljs, forPreview){
	if (fsiFDA) {
		return fsiFDA.warpInHTML(title, maincode, helperjs, externaljs, forPreview);
	}
}

function getFlashWriter(erezprefix){

	htmlcode='<script type="text/javascript" src="'+getFlashWriterURL(erezprefix)+'"><\/script>\n';

	return htmlcode;
}

function getFlashWriterURL(erezprefix){

	writerurl=erezprefix+'fsiwriter.js';

	return writerurl;
}


var fsiFDA;
if (!fsiFDA) {
	fsiFDA = new flashDetectorAdvanced(fsiPresetFlashVersion, fsiImageFallbackLinked, fsiTextFallbackActive, fsiTextFallbackText, flashFallbackImage);
	fsiFDA.init();
}

// Copyright 2013 NeptuneLabs GmbH (http://www.neptunelabs.com)
